--- old/./mr_sas_tbolt.c	Tue Nov  6 14:29:40 2012
+++ new/./mr_sas_tbolt.c	Tue Nov  6 14:29:40 2012
@@ -16,7 +16,6 @@
  */
 
 
-#include <stddef.h>
 #include <sys/types.h>
 #include <sys/file.h>
 #include <sys/atomic.h>
@@ -26,25 +25,31 @@
 #include "mr_sas.h"
 #include "fusion.h"
 
+/*
+ * FMA header files
+ */
+#include <sys/ddifm.h>
+#include <sys/fm/protocol.h>
+#include <sys/fm/util.h>
+#include <sys/fm/io/ddi.h>
 
-// Pre-TB command size and TB command size.
-#define	MR_COMMAND_SIZE (64*20)	// 1280 bytes
+
+/* Pre-TB command size and TB command size. */
+#define	MR_COMMAND_SIZE (64*20)	/* 1280 bytes */
 MR_LD_RAID *MR_LdRaidGet(U32 ld, MR_FW_RAID_MAP_ALL *map);
 U16 MR_TargetIdToLdGet(U32 ldTgtId, MR_FW_RAID_MAP_ALL *map);
 U16 MR_GetLDTgtId(U32 ld, MR_FW_RAID_MAP_ALL *map);
-U16 get_updated_dev_handle(PLD_LOAD_BALANCE_INFO lbInfo, struct IO_REQUEST_INFO *in_info);
+U16 get_updated_dev_handle(PLD_LOAD_BALANCE_INFO, struct IO_REQUEST_INFO *);
 extern ddi_dma_attr_t mrsas_generic_dma_attr;
 extern uint32_t mrsas_tbolt_max_cap_maxxfer;
 extern struct ddi_device_acc_attr endian_attr;
-extern int 	debug_level_g;
+extern int	debug_level_g;
 extern unsigned int	enable_fp;
 volatile int dump_io_wait_time = 90;
 extern void
 io_timeout_checker(void *arg);
-extern int
-mfi_state_transition_to_ready(struct mrsas_instance *instance);
 extern volatile int  debug_timeout_g;
-extern int 	mrsas_issue_pending_cmds(struct mrsas_instance *);
+extern int	mrsas_issue_pending_cmds(struct mrsas_instance *);
 extern int mrsas_complete_pending_cmds(struct mrsas_instance *instance);
 extern void	push_pending_mfi_pkt(struct mrsas_instance *,
 			struct mrsas_cmd *);
@@ -51,8 +56,22 @@
 extern U8 MR_BuildRaidContext(struct mrsas_instance *, struct IO_REQUEST_INFO *,
 	    MPI2_SCSI_IO_VENDOR_UNIQUE *, MR_FW_RAID_MAP_ALL *);
 
-static volatile int  debug_tbolt_fw_faults_after_ocr_g  = 0;
+/* Local static prototypes. */
+static struct mrsas_cmd *mrsas_tbolt_build_cmd(struct mrsas_instance *,
+    struct scsi_address *, struct scsi_pkt *, uchar_t *);
+static void mrsas_tbolt_set_pd_lba(U8 cdb[], uint8_t *cdb_len_ptr,
+    U64 start_blk, U32 num_blocks);
+static int mrsas_tbolt_check_map_info(struct mrsas_instance *);
+static int mrsas_tbolt_sync_map_info(struct mrsas_instance *);
+static int mrsas_tbolt_prepare_pkt(struct scsa_cmd *);
+static int mrsas_tbolt_ioc_init(struct mrsas_instance *, dma_obj_t *);
+#ifdef PDSUPPORT
+static void mrsas_tbolt_get_pd_info(struct mrsas_instance *,
+    struct mrsas_tbolt_pd_info *, int);
+#endif /* PDSUPPORT */
 
+static int debug_tbolt_fw_faults_after_ocr_g = 0;
+
 /*
  * destroy_mfi_mpi_frame_pool
  */
@@ -66,10 +85,11 @@
 	/* return all mfi frames to pool */
 	for (i = 0; i < MRSAS_APP_RESERVED_CMDS; i++) {
 		cmd = instance->cmd_list[i];
-		if (cmd->frame_dma_obj_status == DMA_OBJ_ALLOCATED)
+		if (cmd->frame_dma_obj_status == DMA_OBJ_ALLOCATED) {
 			(void) mrsas_free_dma_obj(instance,
 			    cmd->frame_dma_obj);
-		cmd->frame_dma_obj_status  = DMA_OBJ_FREED;
+		}
+		cmd->frame_dma_obj_status = DMA_OBJ_FREED;
 	}
 }
 
@@ -95,11 +115,12 @@
 mrsas_tbolt_free_additional_dma_buffer(struct mrsas_instance *instance)
 {
 	int i;
-	 if (instance->mfi_internal_dma_obj.status == DMA_OBJ_ALLOCATED) {
-                (void) mrsas_free_dma_obj(instance,
-                    instance->mfi_internal_dma_obj);
-                instance->mfi_internal_dma_obj.status = DMA_OBJ_FREED;
-        }
+
+	if (instance->mfi_internal_dma_obj.status == DMA_OBJ_ALLOCATED) {
+		(void) mrsas_free_dma_obj(instance,
+		    instance->mfi_internal_dma_obj);
+		instance->mfi_internal_dma_obj.status = DMA_OBJ_FREED;
+	}
 	if (instance->mfi_evt_detail_obj.status == DMA_OBJ_ALLOCATED) {
 		(void) mrsas_free_dma_obj(instance,
 		    instance->mfi_evt_detail_obj);
@@ -109,7 +130,7 @@
 	for (i = 0; i < 2; i++) {
 		if (instance->ld_map_obj[i].status == DMA_OBJ_ALLOCATED) {
 			(void) mrsas_free_dma_obj(instance,
-		    	instance->ld_map_obj[i]);
+			    instance->ld_map_obj[i]);
 			instance->ld_map_obj[i].status = DMA_OBJ_FREED;
 		}
 	}
@@ -145,14 +166,13 @@
 create_mpi2_frame_pool(struct mrsas_instance *instance)
 {
 	int		i = 0;
-	int		cookie_cnt;
 	uint16_t	max_cmd;
 	uint32_t	sgl_sz;
 	uint32_t	raid_msg_size;
 	uint32_t	total_size;
-	uint32_t  	offset;
-	uint32_t 	io_req_base_phys;
-	uint8_t 	*io_req_base;
+	uint32_t	offset;
+	uint32_t	io_req_base_phys;
+	uint8_t		*io_req_base;
 	struct mrsas_cmd	*cmd;
 
 	max_cmd = instance->max_fw_cmds;
@@ -160,12 +180,12 @@
 	sgl_sz		= 1024;
 	raid_msg_size	= MRSAS_THUNDERBOLT_MSG_SIZE;
 
-	// Allocating additional 256 bytes to accomodate SMID 0.
+	/* Allocating additional 256 bytes to accomodate SMID 0. */
 	total_size = MRSAS_THUNDERBOLT_MSG_SIZE + (max_cmd * raid_msg_size) +
 	    (max_cmd * sgl_sz) + (max_cmd * SENSE_LENGTH);
 
 	con_log(CL_ANN1, (CE_NOTE, "create_mpi2_frame_pool: "
-	    "max_cmd %x ", max_cmd));
+	    "max_cmd %x", max_cmd));
 
 	con_log(CL_DLEVEL3, (CE_NOTE, "create_mpi2_frame_pool: "
 	    "request message frame pool size %x", total_size));
@@ -203,12 +223,10 @@
 	    (uint32_t)
 	    instance->mpi2_frame_pool_dma_obj.dma_cookie[0].dmac_address;
 
-	con_log(CL_DLEVEL3, (CE_NOTE,
-	    "io_request_frames 0x%x",
-	    instance->io_request_frames));
+	con_log(CL_DLEVEL3, (CE_NOTE, "io_request_frames 0x%p",
+	    (void *)instance->io_request_frames));
 
-	con_log(CL_DLEVEL3, (CE_NOTE,
-	    "io_request_frames_phy 0x%x",
+	con_log(CL_DLEVEL3, (CE_NOTE, "io_request_frames_phy 0x%x",
 	    instance->io_request_frames_phy));
 
 	io_req_base = (uint8_t *)instance->io_request_frames +
@@ -228,50 +246,39 @@
 		    ((uint8_t *)io_req_base + offset);
 		cmd->scsi_io_request_phys_addr = io_req_base_phys + offset;
 
-		cmd->sgl = (Mpi2SGEIOUnion_t *)
-		    ((uint8_t *)io_req_base +
-		    (max_cmd * raid_msg_size) +  i * sgl_sz);
+		cmd->sgl = (Mpi2SGEIOUnion_t *)((uint8_t *)io_req_base +
+		    (max_cmd * raid_msg_size) + i * sgl_sz);
 
-		cmd->sgl_phys_addr =
-		    (io_req_base_phys +
+		cmd->sgl_phys_addr = (io_req_base_phys +
 		    (max_cmd * raid_msg_size) + i * sgl_sz);
 
-		cmd->sense1 = (uint8_t *)
-		    ((uint8_t *)io_req_base +
+		cmd->sense1 = (uint8_t *)((uint8_t *)io_req_base +
 		    (max_cmd * raid_msg_size) + (max_cmd * sgl_sz) +
 		    (i * SENSE_LENGTH));
 
-		cmd->sense_phys_addr1 =
-		    (io_req_base_phys +
+		cmd->sense_phys_addr1 = (io_req_base_phys +
 		    (max_cmd * raid_msg_size) + (max_cmd * sgl_sz) +
 		    (i * SENSE_LENGTH));
 
 
-		cmd->SMID = i+1;
+		cmd->SMID = i + 1;
 
-		con_log(CL_DLEVEL3, (CE_NOTE,
-		    "Frame Pool Addr [%x]0x%x",
-		    cmd->index, cmd->scsi_io_request));
+		con_log(CL_DLEVEL3, (CE_NOTE, "Frame Pool Addr [%x]0x%p",
+		    cmd->index, (void *)cmd->scsi_io_request));
 
-		con_log(CL_DLEVEL3, (CE_NOTE,
-		    "Frame Pool Phys Addr [%x]0x%x",
+		con_log(CL_DLEVEL3, (CE_NOTE, "Frame Pool Phys Addr [%x]0x%x",
 		    cmd->index, cmd->scsi_io_request_phys_addr));
 
-		con_log(CL_DLEVEL3, (CE_NOTE,
-		    "Sense Addr [%x]0x%x",
-		    cmd->index, cmd->sense1));
+		con_log(CL_DLEVEL3, (CE_NOTE, "Sense Addr [%x]0x%p",
+		    cmd->index, (void *)cmd->sense1));
 
-		con_log(CL_DLEVEL3, (CE_NOTE,
-		    "Sense Addr Phys [%x]0x%x",
+		con_log(CL_DLEVEL3, (CE_NOTE, "Sense Addr Phys [%x]0x%x",
 		    cmd->index, cmd->sense_phys_addr1));
 
+		con_log(CL_DLEVEL3, (CE_NOTE, "Sgl bufffers [%x]0x%p",
+		    cmd->index, (void *)cmd->sgl));
 
-		con_log(CL_DLEVEL3, (CE_NOTE,
-		    "Sgl bufffers [%x]0x%x",
-		    cmd->index, cmd->sgl));
-
-		con_log(CL_DLEVEL3, (CE_NOTE,
-		    "Sgl bufffers phys  [%x]0x%x",
+		con_log(CL_DLEVEL3, (CE_NOTE, "Sgl bufffers phys [%x]0x%x",
 		    cmd->index, cmd->sgl_phys_addr));
 	}
 
@@ -286,7 +293,7 @@
 int
 mrsas_tbolt_alloc_additional_dma_buffer(struct mrsas_instance *instance)
 {
-	uint32_t        internal_buf_size = PAGESIZE*2;	
+	uint32_t	internal_buf_size = PAGESIZE*2;
 	int i;
 
 	/* Initialize buffer status as free */
@@ -299,25 +306,26 @@
 	instance->mfi_internal_dma_obj.size = internal_buf_size;
 	instance->mfi_internal_dma_obj.dma_attr = mrsas_generic_dma_attr;
 	instance->mfi_internal_dma_obj.dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
-	instance->mfi_internal_dma_obj.dma_attr.dma_attr_count_max = 0xFFFFFFFFU;
+	instance->mfi_internal_dma_obj.dma_attr.dma_attr_count_max =
+	    0xFFFFFFFFU;
 	instance->mfi_internal_dma_obj.dma_attr.dma_attr_sgllen = 1;
 
 	if (mrsas_alloc_dma_obj(instance, &instance->mfi_internal_dma_obj,
-			(uchar_t)DDI_STRUCTURE_LE_ACC) != 1) {
+	    (uchar_t)DDI_STRUCTURE_LE_ACC) != 1) {
 		cmn_err(CE_WARN,
-			"mr_sas: could not alloc reply queue");
+		    "mr_sas: could not alloc reply queue");
 		return (DDI_FAILURE);
 	}
 
 	bzero(instance->mfi_internal_dma_obj.buffer, internal_buf_size);
 
-	instance->mfi_internal_dma_obj.status |= DMA_OBJ_ALLOCATED;	
-	instance->internal_buf = (caddr_t)(((unsigned long)
-	instance->mfi_internal_dma_obj.buffer));
+	instance->mfi_internal_dma_obj.status |= DMA_OBJ_ALLOCATED;
+	instance->internal_buf =
+	    (caddr_t)(((unsigned long)instance->mfi_internal_dma_obj.buffer));
 	instance->internal_buf_dmac_add =
-	instance->mfi_internal_dma_obj.dma_cookie[0].dmac_address; 
+	    instance->mfi_internal_dma_obj.dma_cookie[0].dmac_address;
 	instance->internal_buf_size = internal_buf_size;
-         
+
 	/* allocate evt_detail */
 	instance->mfi_evt_detail_obj.size = sizeof (struct mrsas_evt_detail);
 	instance->mfi_evt_detail_obj.dma_attr = mrsas_generic_dma_attr;
@@ -328,8 +336,7 @@
 
 	if (mrsas_alloc_dma_obj(instance, &instance->mfi_evt_detail_obj,
 	    (uchar_t)DDI_STRUCTURE_LE_ACC) != 1) {
-		cmn_err(CE_WARN,
-		    "mrsas_tbolt_alloc_additional_dma_buffer: "
+		cmn_err(CE_WARN, "mrsas_tbolt_alloc_additional_dma_buffer: "
 		    "could not allocate data transfer buffer.");
 		goto fail_tbolt_additional_buff;
 	}
@@ -347,32 +354,32 @@
 		instance->ld_map_obj[i].size = instance->size_map_info;
 		instance->ld_map_obj[i].dma_attr = mrsas_generic_dma_attr;
 		instance->ld_map_obj[i].dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
-		instance->ld_map_obj[i].dma_attr.dma_attr_count_max = 0xFFFFFFFFU;
+		instance->ld_map_obj[i].dma_attr.dma_attr_count_max =
+		    0xFFFFFFFFU;
 		instance->ld_map_obj[i].dma_attr.dma_attr_sgllen = 1;
 		instance->ld_map_obj[i].dma_attr.dma_attr_align = 1;
 
 		if (mrsas_alloc_dma_obj(instance, &instance->ld_map_obj[i],
-	    		(uchar_t)DDI_STRUCTURE_LE_ACC) != 1) {
+		    (uchar_t)DDI_STRUCTURE_LE_ACC) != 1) {
 			cmn_err(CE_WARN,
-		    	"could not allocate data transfer buffer.");
+			    "could not allocate data transfer buffer.");
 			goto fail_tbolt_additional_buff;
 		}
 
 		instance->ld_map_obj[i].status |= DMA_OBJ_ALLOCATED;
 
-		(void) memset(instance->ld_map_obj[i].buffer, 0,
-	    	instance->size_map_info);
+		bzero(instance->ld_map_obj[i].buffer, instance->size_map_info);
 
-		instance->ld_map[i] = (MR_FW_RAID_MAP_ALL *)instance->ld_map_obj[i].buffer;
-		instance->ld_map_phy[i] =
-	    		(uint32_t)instance->ld_map_obj[i].dma_cookie[0].dmac_address;
+		instance->ld_map[i] =
+		    (MR_FW_RAID_MAP_ALL *)instance->ld_map_obj[i].buffer;
+		instance->ld_map_phy[i] = (uint32_t)instance->
+		    ld_map_obj[i].dma_cookie[0].dmac_address;
 
 		con_log(CL_DLEVEL3, (CE_NOTE,
-			"ld_map Addr Phys 0x%x", instance->ld_map_phy[i]));
+		    "ld_map Addr Phys 0x%x", instance->ld_map_phy[i]));
 
 		con_log(CL_DLEVEL3, (CE_NOTE,
-			"size_map_info 0x%x", instance->size_map_info));
-
+		    "size_map_info 0x%x", instance->size_map_info));
 	}
 
 	return (DDI_SUCCESS);
@@ -384,8 +391,7 @@
 }
 
 MRSAS_REQUEST_DESCRIPTOR_UNION *
-mr_sas_get_request_descriptor(struct mrsas_instance *instance,
-    uint16_t index, struct mrsas_cmd *cmd)
+mr_sas_get_request_descriptor(struct mrsas_instance *instance, uint16_t index)
 {
 	MRSAS_REQUEST_DESCRIPTOR_UNION *req_desc;
 
@@ -393,7 +399,7 @@
 		con_log(CL_ANN1, (CE_NOTE,
 		    "Invalid SMID 0x%x request for descriptor", index));
 		con_log(CL_ANN1, (CE_NOTE,
-		    "max_fw_cmds : 0x%x\n", instance->max_fw_cmds));
+		    "max_fw_cmds : 0x%x", instance->max_fw_cmds));
 		return (NULL);
 	}
 
@@ -402,10 +408,10 @@
 	    (sizeof (MRSAS_REQUEST_DESCRIPTOR_UNION) * index));
 
 	con_log(CL_ANN1, (CE_NOTE,
-	    "request descriptor : 0x%08lx\n", (unsigned long)req_desc));
+	    "request descriptor : 0x%08lx", (unsigned long)req_desc));
 
 	con_log(CL_ANN1, (CE_NOTE,
-	    "request descriptor base phy : 0x%08lx\n",
+	    "request descriptor base phy : 0x%08lx",
 	    (unsigned long)instance->request_message_pool_phy));
 
 	return ((MRSAS_REQUEST_DESCRIPTOR_UNION *)req_desc);
@@ -419,10 +425,8 @@
 alloc_req_rep_desc(struct mrsas_instance *instance)
 {
 	uint32_t	request_q_sz, reply_q_sz;
-	int 		i, max_request_q_sz, max_reply_q_sz;
-	uint64_t	request_desc;
+	int		i, max_reply_q_sz;
 	MPI2_REPLY_DESCRIPTORS_UNION *reply_desc;
-	uint64_t	*reply_ptr;
 
 	/*
 	 * ThunderBolt(TB) There's no longer producer consumer mechanism.
@@ -432,17 +436,17 @@
 	 */
 
 	/* Allocate Reply Descriptors */
-	con_log(CL_ANN1, (CE_NOTE, " reply q desc len = %x\n",
-	    sizeof (MPI2_REPLY_DESCRIPTORS_UNION)));
+	con_log(CL_ANN1, (CE_NOTE, " reply q desc len = %x",
+	    (uint_t)sizeof (MPI2_REPLY_DESCRIPTORS_UNION)));
 
-	// reply queue size should be multiple of 16
+	/* reply queue size should be multiple of 16 */
 	max_reply_q_sz = ((instance->max_fw_cmds + 1 + 15)/16)*16;
 
 	reply_q_sz = 8 * max_reply_q_sz;
 
 
-	con_log(CL_ANN1, (CE_NOTE, " reply q desc len = %x\n",
-	    sizeof (MPI2_REPLY_DESCRIPTORS_UNION)));
+	con_log(CL_ANN1, (CE_NOTE, " reply q desc len = %x",
+	    (uint_t)sizeof (MPI2_REPLY_DESCRIPTORS_UNION)));
 
 	instance->reply_desc_dma_obj.size = reply_q_sz;
 	instance->reply_desc_dma_obj.dma_attr = mrsas_generic_dma_attr;
@@ -452,7 +456,7 @@
 	instance->reply_desc_dma_obj.dma_attr.dma_attr_align = 16;
 
 	if (mrsas_alloc_dma_obj(instance, &instance->reply_desc_dma_obj,
-			(uchar_t)DDI_STRUCTURE_LE_ACC) != 1) {
+	    (uchar_t)DDI_STRUCTURE_LE_ACC) != 1) {
 		cmn_err(CE_WARN,
 		    "mr_sas: could not alloc reply queue");
 		return (DDI_FAILURE);
@@ -461,7 +465,7 @@
 	bzero(instance->reply_desc_dma_obj.buffer, reply_q_sz);
 	instance->reply_desc_dma_obj.status |= DMA_OBJ_ALLOCATED;
 
-	// virtual address of  reply queue
+	/* virtual address of  reply queue */
 	instance->reply_frame_pool = (MPI2_REPLY_DESCRIPTORS_UNION *)(
 	    instance->reply_desc_dma_obj.buffer);
 
@@ -470,8 +474,8 @@
 	con_log(CL_ANN1, (CE_NOTE, "[reply queue depth]0x%x",
 	    instance->reply_q_depth));
 
-	con_log(CL_ANN1, (CE_NOTE, "[reply queue virt addr]0x%x",
-	    instance->reply_frame_pool));
+	con_log(CL_ANN1, (CE_NOTE, "[reply queue virt addr]0x%p",
+	    (void *)instance->reply_frame_pool));
 
 	/* initializing reply address to 0xFFFFFFFF */
 	reply_desc = instance->reply_frame_pool;
@@ -496,12 +500,12 @@
 	    instance->reply_pool_limit_phy));
 
 
-	con_log(CL_ANN1, (CE_NOTE, " request q desc len = %x\n",
-	    sizeof (MRSAS_REQUEST_DESCRIPTOR_UNION)));
+	con_log(CL_ANN1, (CE_NOTE, " request q desc len = %x",
+	    (int)sizeof (MRSAS_REQUEST_DESCRIPTOR_UNION)));
 
 	/* Allocate Request Descriptors */
-	con_log(CL_ANN1, (CE_NOTE, " request q desc len = %x\n",
-	    sizeof (MRSAS_REQUEST_DESCRIPTOR_UNION)));
+	con_log(CL_ANN1, (CE_NOTE, " request q desc len = %x",
+	    (int)sizeof (MRSAS_REQUEST_DESCRIPTOR_UNION)));
 
 	request_q_sz = 8 *
 	    (instance->max_fw_cmds);
@@ -509,7 +513,8 @@
 	instance->request_desc_dma_obj.size = request_q_sz;
 	instance->request_desc_dma_obj.dma_attr	= mrsas_generic_dma_attr;
 	instance->request_desc_dma_obj.dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
-	instance->request_desc_dma_obj.dma_attr.dma_attr_count_max = 0xFFFFFFFFU;
+	instance->request_desc_dma_obj.dma_attr.dma_attr_count_max =
+	    0xFFFFFFFFU;
 	instance->request_desc_dma_obj.dma_attr.dma_attr_sgllen	= 1;
 	instance->request_desc_dma_obj.dma_attr.dma_attr_align = 16;
 
@@ -530,8 +535,6 @@
 	instance->request_message_pool_phy =
 	    (uint32_t)instance->request_desc_dma_obj.dma_cookie[0].dmac_address;
 
-	max_request_q_sz = instance->max_fw_cmds;
-
 	return (DDI_SUCCESS);
 
 fail_undo_reply_queue:
@@ -546,7 +549,9 @@
 
 /*
  * mrsas_alloc_cmd_pool_tbolt
- * TODO: merge tbolt-specific codee into mrsas_alloc_cmd_pool() to have single routine
+ *
+ * TODO: merge tbolt-specific code into mrsas_alloc_cmd_pool() to have single
+ * routine
  */
 int
 mrsas_alloc_cmd_pool_tbolt(struct mrsas_instance *instance)
@@ -572,21 +577,11 @@
 	 * commands.
 	 */
 	instance->cmd_list = kmem_zalloc(sz, KM_SLEEP);
-	if (instance->cmd_list == NULL) {
-		con_log(CL_NONE, (CE_WARN,
-		    "Failed to allocate memory for cmd_list"));
-		return (DDI_FAILURE);
-	}
 
 	/* create a frame pool and assign one frame to each cmd */
 	for (count = 0; count < max_cmd; count++) {
-		instance->cmd_list[count] = kmem_zalloc(sizeof (struct mrsas_cmd),
-		    KM_SLEEP);
-		if (instance->cmd_list[count] == NULL) {
-			con_log(CL_NONE, (CE_WARN,
-				"Failed to allocate memory for mrsas_cmd"));
-			goto mrsas_undo_cmds;
-		}
+		instance->cmd_list[count] =
+		    kmem_zalloc(sizeof (struct mrsas_cmd), KM_SLEEP);
 	}
 
 	/* add all the commands to command pool */
@@ -595,15 +590,16 @@
 	INIT_LIST_HEAD(&instance->cmd_pend_list);
 	INIT_LIST_HEAD(&instance->cmd_app_pool_list);
 
-	reserve_cmd	= MRSAS_APP_RESERVED_CMDS;
+	reserve_cmd = MRSAS_APP_RESERVED_CMDS;
 
-	for (i = 1; i < reserve_cmd; i++) {    //cmd index 0 reservered for IOC INIT
+	/* cmd index 0 reservered for IOC INIT */
+	for (i = 1; i < reserve_cmd; i++) {
 		cmd		= instance->cmd_list[i];
 		cmd->index	= i;
 		mlist_add_tail(&cmd->list, &instance->cmd_app_pool_list);
 	}
-	
 
+
 	for (i = reserve_cmd; i < max_cmd; i++) {
 		cmd		= instance->cmd_list[i];
 		cmd->index	= i;
@@ -616,8 +612,10 @@
 	if (count > 0) {
 		/* free each cmd */
 		for (i = 0; i < count; i++) {
-			if (instance->cmd_list[i] != NULL)
-				kmem_free(instance->cmd_list[i],sizeof (struct mrsas_cmd));
+			if (instance->cmd_list[i] != NULL) {
+				kmem_free(instance->cmd_list[i],
+				    sizeof (struct mrsas_cmd));
+			}
 			instance->cmd_list[i] = NULL;
 		}
 	}
@@ -624,7 +622,7 @@
 
 mrsas_undo_cmd_list:
 	if (instance->cmd_list != NULL)
-		kmem_free(instance->cmd_list,sz);
+		kmem_free(instance->cmd_list, sz);
 	instance->cmd_list = NULL;
 
 	return (DDI_FAILURE);
@@ -666,10 +664,10 @@
 int
 alloc_space_for_mpi2(struct mrsas_instance *instance)
 {
-	/* Allocate command pool ( memory for cmd_list & individual commands )*/
+	/* Allocate command pool (memory for cmd_list & individual commands) */
 	if (mrsas_alloc_cmd_pool_tbolt(instance)) {
 		cmn_err(CE_WARN, "Error creating cmd pool");
-		return (DDI_FAILURE); 
+		return (DDI_FAILURE);
 	}
 
 	/* Initialize single reply size and Message size */
@@ -696,7 +694,7 @@
 	/* Make sure the buffer is aligned to 8 for req/rep  descriptor Pool */
 	if (alloc_req_rep_desc(instance)) {
 		cmn_err(CE_WARN,
-			"Error, allocating memory for descripter-pool");
+		    "Error, allocating memory for descripter-pool");
 		goto mpi2_undo_cmd_pool;
 	}
 	con_log(CL_ANN1, (CE_NOTE, "[request message pool phys addr]0x%x",
@@ -706,7 +704,7 @@
 	/* Allocate MFI Frame pool - for MPI-MFI passthru commands */
 	if (create_mfi_frame_pool(instance)) {
 		cmn_err(CE_WARN,
-			"Error, allocating memory for MFI frame-pool");
+		    "Error, allocating memory for MFI frame-pool");
 		goto mpi2_undo_descripter_pool;
 	}
 
@@ -719,7 +717,7 @@
 
 	if (create_mpi2_frame_pool(instance)) {
 		cmn_err(CE_WARN,
-			"Error, allocating memory for MPI2 Message-pool");
+		    "Error, allocating memory for MPI2 Message-pool");
 		goto mpi2_undo_mfi_frame_pool;
 	}
 
@@ -740,7 +738,7 @@
 	/* Allocate additional dma buffer */
 	if (mrsas_tbolt_alloc_additional_dma_buffer(instance)) {
 		cmn_err(CE_WARN,
-			"Error, allocating tbolt additional DMA buffer");
+		    "Error, allocating tbolt additional DMA buffer");
 		goto mpi2_undo_message_pool;
 	}
 
@@ -766,7 +764,7 @@
  * mrsas_init_adapter_tbolt - Initialize fusion interface adapter.
  */
 int
-mrsas_init_adapter_tbolt (struct mrsas_instance *instance)
+mrsas_init_adapter_tbolt(struct mrsas_instance *instance)
 {
 
 	/*
@@ -781,11 +779,11 @@
 	}
 
 	con_log(CL_ANN, (CE_NOTE, "mrsas_init_adapter_tbolt: "
-		    " instance->max_fw_cmds 0x%X.", instance->max_fw_cmds));
+	    " instance->max_fw_cmds 0x%X.", instance->max_fw_cmds));
 
 
 	/* create a pool of commands */
-	if ( alloc_space_for_mpi2(instance) != DDI_SUCCESS) {
+	if (alloc_space_for_mpi2(instance) != DDI_SUCCESS) {
 		cmn_err(CE_WARN,
 		    " alloc_space_for_mpi2() failed.");
 
@@ -793,7 +791,8 @@
 	}
 
 	/* Send ioc init message */
-	if ( mrsas_issue_init_mpi2(instance) != DDI_SUCCESS) {
+	/* NOTE: the issue_init call does FMA checking already. */
+	if (mrsas_issue_init_mpi2(instance) != DDI_SUCCESS) {
 		cmn_err(CE_WARN,
 		    " mrsas_issue_init_mpi2() failed.");
 
@@ -803,13 +802,11 @@
 	instance->unroll.alloc_space_mpi2 = 1;
 
 	con_log(CL_ANN, (CE_NOTE,
-		    "mrsas_init_adapter_tbolt: SUCCESSFULL\n"));
+	    "mrsas_init_adapter_tbolt: SUCCESSFUL"));
 
 	return (DDI_SUCCESS);
 
 fail_init_fusion:
-
-fail_undo_alloc_mpi2:
 	free_space_for_mpi2(instance);
 
 	return (DDI_FAILURE);
@@ -840,20 +837,18 @@
 		    "could not allocate data transfer buffer.");
 		return (DDI_FAILURE);
 	}
-	(void) memset(init2_dma_obj.buffer, 2,
-	    sizeof (Mpi2IOCInitRequest_t));
+	(void) memset(init2_dma_obj.buffer, 2, sizeof (Mpi2IOCInitRequest_t));
 
 	con_log(CL_ANN1, (CE_NOTE,
-	    "mrsas_issue_init_mpi2 _phys adr: %x \n",
+	    "mrsas_issue_init_mpi2 _phys adr: %x",
 	    init2_dma_obj.dma_cookie[0].dmac_address));
 
 
 	/* Initialize and send ioc init message */
-	ret_val = mrsas_tbolt_ioc_init(instance, &init2_dma_obj,
-	    init2_dma_obj.acc_handle);
+	ret_val = mrsas_tbolt_ioc_init(instance, &init2_dma_obj);
 	if (ret_val == DDI_FAILURE) {
 		con_log(CL_ANN1, (CE_WARN,
-		    "mrsas_issue_init_mpi2: Failed\n"));
+		    "mrsas_issue_init_mpi2: Failed"));
 		goto fail_init_mpi2;
 	}
 
@@ -861,38 +856,36 @@
 	if (mrsas_free_dma_obj(instance, init2_dma_obj)
 	    != DDI_SUCCESS) {
 		con_log(CL_ANN1, (CE_WARN,
-		    "mrsas_issue_init_mpi2: Free Failed\n"));
+		    "mrsas_issue_init_mpi2: Free Failed"));
 		return (DDI_FAILURE);
 	}
 
-
 	/* Get/Check and sync ld_map info */
 	instance->map_id = 0;
-	if( mrsas_tbolt_check_map_info(instance) == DDI_SUCCESS ) 
-	   	mrsas_tbolt_sync_map_info(instance);
-	
+	if (mrsas_tbolt_check_map_info(instance) == DDI_SUCCESS)
+		(void) mrsas_tbolt_sync_map_info(instance);
+
+
+	/* No mrsas_cmd to send, so send NULL. */
+	if (mrsas_common_check(instance, NULL) != DDI_SUCCESS)
+		goto fail_init_mpi2;
+
 	con_log(CL_ANN, (CE_NOTE,
-		    "mrsas_issue_init_mpi2: SUCCESSFULL\n"));
+	    "mrsas_issue_init_mpi2: SUCCESSFUL"));
 
 	return (DDI_SUCCESS);
 
 fail_init_mpi2:
-	mrsas_free_dma_obj(instance, init2_dma_obj);
+	(void) mrsas_free_dma_obj(instance, init2_dma_obj);
 
 	return (DDI_FAILURE);
 }
 
-int
-mrsas_tbolt_ioc_init(struct mrsas_instance *instance, dma_obj_t *mpi2_dma_obj,
-    ddi_acc_handle_t accessp)
+static int
+mrsas_tbolt_ioc_init(struct mrsas_instance *instance, dma_obj_t *mpi2_dma_obj)
 {
-	int				numbytes, i;
-	int ret				= DDI_SUCCESS;
+	int				numbytes;
 	uint16_t			flags;
-	int				status;
-	timespec_t			time;
-	uint64_t			mSec;
-	uint32_t msecs			= MFI_POLL_TIMEOUT_SECS * MILLISEC;
 	struct mrsas_init_frame2	*mfiFrameInit2;
 	struct mrsas_header		*frame_hdr;
 	Mpi2IOCInitRequest_t		*init;
@@ -900,18 +893,17 @@
 	struct mrsas_drv_ver		drv_ver_info;
 	MRSAS_REQUEST_DESCRIPTOR_UNION	*req_desc;
 
-
 	con_log(CL_ANN, (CE_NOTE, "chkpnt:%s:%d", __func__, __LINE__));
 
 
 #ifdef DEBUG
 	con_log(CL_ANN1, (CE_CONT, " mfiFrameInit2 len = %x\n",
-	    sizeof (*mfiFrameInit2)));
-	con_log(CL_ANN1, (CE_CONT, " MPI len = %x\n", sizeof (*init)));
+	    (int)sizeof (*mfiFrameInit2)));
+	con_log(CL_ANN1, (CE_CONT, " MPI len = %x\n", (int)sizeof (*init)));
 	con_log(CL_ANN1, (CE_CONT, " mfiFrameInit2 len = %x\n",
-	    sizeof (struct mrsas_init_frame2)));
+	    (int)sizeof (struct mrsas_init_frame2)));
 	con_log(CL_ANN1, (CE_CONT, " MPI len = %x\n",
-	    sizeof (Mpi2IOCInitRequest_t)));
+	    (int)sizeof (Mpi2IOCInitRequest_t)));
 #endif
 
 	init = (Mpi2IOCInitRequest_t *)mpi2_dma_obj->buffer;
@@ -969,7 +961,7 @@
 	cmd->drv_pkt_time = 0;
 
 	mfiFrameInit2 = (struct mrsas_init_frame2 *)cmd->scsi_io_request;
-	con_log(CL_ANN1, (CE_CONT, "[mfi vaddr]%x", mfiFrameInit2));
+	con_log(CL_ANN1, (CE_CONT, "[mfi vaddr]%p", (void *)mfiFrameInit2));
 
 	frame_hdr = &cmd->frame->hdr;
 
@@ -978,7 +970,7 @@
 
 	flags = ddi_get16(cmd->frame_dma_obj.acc_handle, &frame_hdr->flags);
 
-	flags 	|= MFI_FRAME_DONT_POST_IN_REPLY_QUEUE;
+	flags	|= MFI_FRAME_DONT_POST_IN_REPLY_QUEUE;
 
 	ddi_put16(cmd->frame_dma_obj.acc_handle, &frame_hdr->flags, flags);
 
@@ -985,7 +977,7 @@
 	con_log(CL_ANN, (CE_CONT,
 	    "mrsas_tbolt_ioc_init: SMID:%x\n", cmd->SMID));
 
-	// Init the MFI Header
+	/* Init the MFI Header */
 	ddi_put8(instance->mpi2_frame_pool_dma_obj.acc_handle,
 	    &mfiFrameInit2->cmd, MFI_CMD_OP_INIT);
 
@@ -1006,13 +998,13 @@
 	    sizeof (Mpi2IOCInitRequest_t));
 
 	con_log(CL_ANN1, (CE_CONT, "[reply q desc addr]%x",
-	    init->ReplyDescriptorPostQueueAddress));
+	    (int)init->ReplyDescriptorPostQueueAddress));
 
-	/* fill driver version information*/	
+	/* fill driver version information */
 	fill_up_drv_ver(&drv_ver_info);
-	
+
 	/* allocate the driver version data transfer buffer */
-	instance->drv_ver_dma_obj.size = sizeof(drv_ver_info.drv_ver);
+	instance->drv_ver_dma_obj.size = sizeof (drv_ver_info.drv_ver);
 	instance->drv_ver_dma_obj.dma_attr = mrsas_generic_dma_attr;
 	instance->drv_ver_dma_obj.dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
 	instance->drv_ver_dma_obj.dma_attr.dma_attr_count_max = 0xFFFFFFFFU;
@@ -1025,25 +1017,26 @@
 		    "fusion init: Could not allocate driver version buffer.");
 		return (DDI_FAILURE);
 	}
-	/* copy driver version to dma  buffer*/
-	(void) memset(instance->drv_ver_dma_obj.buffer, 0,sizeof(drv_ver_info.drv_ver));
+	/* copy driver version to dma buffer */
+	bzero(instance->drv_ver_dma_obj.buffer, sizeof (drv_ver_info.drv_ver));
 	ddi_rep_put8(cmd->frame_dma_obj.acc_handle,
-		(uint8_t *)drv_ver_info.drv_ver,
-                (uint8_t *)instance->drv_ver_dma_obj.buffer, 
-		sizeof(drv_ver_info.drv_ver), DDI_DEV_AUTOINCR);	
+	    (uint8_t *)drv_ver_info.drv_ver,
+	    (uint8_t *)instance->drv_ver_dma_obj.buffer,
+	    sizeof (drv_ver_info.drv_ver), DDI_DEV_AUTOINCR);
 
-	/*send driver version physical address to firmware*/
-	ddi_put64(cmd->frame_dma_obj.acc_handle,
-	    &mfiFrameInit2->driverversion, instance->drv_ver_dma_obj.dma_cookie[0].dmac_address);
+	/* send driver version physical address to firmware */
+	ddi_put64(cmd->frame_dma_obj.acc_handle, &mfiFrameInit2->driverversion,
+	    instance->drv_ver_dma_obj.dma_cookie[0].dmac_address);
 
 	con_log(CL_ANN1, (CE_CONT, "[MPIINIT2 frame Phys addr ]0x%x len = %x",
 	    mfiFrameInit2->queue_info_new_phys_addr_lo,
-	    sizeof (Mpi2IOCInitRequest_t)));
+	    (int)sizeof (Mpi2IOCInitRequest_t)));
 
 	con_log(CL_ANN1, (CE_CONT, "[Length]%x", mfiFrameInit2->data_xfer_len));
 
 	con_log(CL_ANN1, (CE_CONT, "[MFI frame Phys Address]%x len = %x",
-	    cmd->scsi_io_request_phys_addr, sizeof (struct mrsas_init_frame2)));
+	    cmd->scsi_io_request_phys_addr,
+	    (int)sizeof (struct mrsas_init_frame2)));
 
 	/* disable interrupts before sending INIT2 frame */
 	instance->func_ptr->disable_intr(instance);
@@ -1066,7 +1059,6 @@
 	if (ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle,
 	    &mfiFrameInit2->cmd_status) == 0) {
 		con_log(CL_ANN, (CE_NOTE, "INIT2 Success"));
-		ret = DDI_SUCCESS;
 	} else {
 		con_log(CL_ANN, (CE_WARN, "INIT2 Fail"));
 		mrsas_dump_reply_desc(instance);
@@ -1077,21 +1069,20 @@
 
 	instance->unroll.verBuff = 1;
 
-	con_log(CL_ANN, (CE_NOTE,
-		    "mrsas_tbolt_ioc_init: SUCCESSFULL\n"));
+	con_log(CL_ANN, (CE_NOTE, "mrsas_tbolt_ioc_init: SUCCESSFUL"));
 
-
 	return (DDI_SUCCESS);
 
 
 fail_ioc_init:
 
-	mrsas_free_dma_obj(instance, instance->drv_ver_dma_obj);
+	(void) mrsas_free_dma_obj(instance, instance->drv_ver_dma_obj);
 
 	return (DDI_FAILURE);
 }
 
-int wait_for_outstanding_poll_io(struct mrsas_instance *instance)
+int
+wait_for_outstanding_poll_io(struct mrsas_instance *instance)
 {
 	int i;
 	uint32_t wait_time = dump_io_wait_time;
@@ -1124,10 +1115,7 @@
 	struct mrsas_instance	*instance = ADDR2MR(ap);
 	struct scsa_cmd		*acmd = PKT2CMD(pkt);
 	struct mrsas_cmd	*cmd = NULL;
-	int			rval, i;
-	uchar_t 		cmd_done = 0;
-	Mpi2RaidSCSIIORequest_t *scsi_raid_io;
-	uint32_t		msecs = 120 * MILLISEC;
+	uchar_t			cmd_done = 0;
 
 	con_log(CL_DLEVEL1, (CE_NOTE, "chkpnt:%s:%d", __func__, __LINE__));
 	if (instance->deadadapter == 1) {
@@ -1145,7 +1133,7 @@
 		    "returning mfi_pkt and setting TRAN_BUSY\n"));
 		return (TRAN_BUSY);
 	}
-	rval = mrsas_tbolt_prepare_pkt(acmd);
+	(void) mrsas_tbolt_prepare_pkt(acmd);
 
 	cmd = mrsas_tbolt_build_cmd(instance, ap, pkt, &cmd_done);
 
@@ -1174,7 +1162,7 @@
 	if ((pkt->pkt_flags & FLAG_NOINTR) == 0) {
 		if (instance->fw_outstanding > instance->max_fw_cmds) {
 			cmn_err(CE_WARN,
-			    "Command Queue Full... Returning BUSY \n");
+			    "Command Queue Full... Returning BUSY");
 			return_raid_msg_pkt(instance, cmd);
 			return (TRAN_BUSY);
 		}
@@ -1184,17 +1172,17 @@
 		    DDI_DMA_SYNC_FORDEV);
 
 		con_log(CL_ANN, (CE_CONT, "tbolt_issue_cmd: SCSI CDB[0]=0x%x "
-		    "cmd->index:0x%x SMID %0x%x\n", pkt->pkt_cdbp[0], cmd->index, cmd->SMID));
+		    "cmd->index:0x%x SMID 0x%x\n", pkt->pkt_cdbp[0],
+		    cmd->index, cmd->SMID));
 
 		instance->func_ptr->issue_cmd(cmd, instance);
-
-		return (TRAN_ACCEPT);
-
 	} else {
-		instance->func_ptr->issue_cmd(cmd, instance);	
+		instance->func_ptr->issue_cmd(cmd, instance);
 		(void) wait_for_outstanding_poll_io(instance);
-		return (TRAN_ACCEPT);
+		(void) mrsas_common_check(instance, cmd);
 	}
+
+	return (TRAN_ACCEPT);
 }
 
 /*
@@ -1202,7 +1190,7 @@
  * the pkt may have been resubmitted or just reused so
  * initialize some fields and do some checks.
  */
-int
+static int
 mrsas_tbolt_prepare_pkt(struct scsa_cmd *acmd)
 {
 	struct scsi_pkt	*pkt = CMD2PKT(acmd);
@@ -1235,11 +1223,12 @@
 {
 	uint32_t		MaxSGEs;
 	int			sg_to_process;
-	uint32_t		i, j, SGEdwords = 0;
+	uint32_t		i, j;
 	uint32_t		numElements, endElement;
 	Mpi25IeeeSgeChain64_t	*ieeeChainElement = NULL;
 	Mpi25IeeeSgeChain64_t	*scsi_raid_io_sgl_ieee = NULL;
-	uint32_t		SGLFlags = 0;
+	ddi_acc_handle_t acc_handle =
+	    instance->mpi2_frame_pool_dma_obj.acc_handle;
 
 	con_log(CL_ANN1, (CE_NOTE,
 	    "chkpnt: Building Chained SGL :%d", __LINE__));
@@ -1248,25 +1237,21 @@
 	/* Clear the datalen before updating it. */
 	*datalen = 0;
 
-	SGEdwords = sizeof (Mpi25IeeeSgeChain64_t) / 4;
-
 	MaxSGEs = instance->max_sge_in_main_msg;
 
-	ddi_put16(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io->SGLFlags,
+	ddi_put16(acc_handle, &scsi_raid_io->SGLFlags,
 	    MPI2_SGE_FLAGS_64_BIT_ADDRESSING);
 
-	// set data transfer flag.
+	/* set data transfer flag. */
 	if (acmd->cmd_flags & CFLAG_DMASEND) {
-		ddi_put32(instance->mpi2_frame_pool_dma_obj.acc_handle,
-		    &scsi_raid_io->Control,
+		ddi_put32(acc_handle, &scsi_raid_io->Control,
 		    MPI2_SCSIIO_CONTROL_WRITE);
 	} else {
-		ddi_put32(instance->mpi2_frame_pool_dma_obj.acc_handle,
-		    &scsi_raid_io->Control, MPI2_SCSIIO_CONTROL_READ);
+		ddi_put32(acc_handle, &scsi_raid_io->Control,
+		    MPI2_SCSIIO_CONTROL_READ);
 	}
 
-	
+
 	numElements = acmd->cmd_cookiecnt;
 
 	con_log(CL_DLEVEL1, (CE_NOTE, "[SGE Count]:%x", numElements));
